/*******************************************************************************
**
**    Cabletron Systems Incorporated
**    Post Office Box 5005
**    Rochester, NH 03866-5005
**    (c) Copyright Cabletron Systems Inc. 1999
**
**    Workfile:             %M%
**    Logfile:              %P%
**    Original Author:      Todd Crowley
**    SCCS Delta ID:        %I%
**    Last Delta Date/Time: %G% %U%
**
*******************************************************************************/

#ifndef LFAPAR_H_
#define LFAPAR_H_

#include "Lfap.h"


#ifdef __cplusplus
extern "C" {
#endif

#define LFAP_AR_INVALID			 0
#define LFAP_AR_VALID			 1
#define LFAP_AR_COMMAND			 1
#define LFAP_AR_FLOW_ID			 2
#define LFAP_AR_FAS_IP_ADDR		 4

typedef struct lfap_ar_msg
{
  LFAPBuffer	lfap_msg;
    LFAPHeader	hdr;
    LFAPIE	command;
    LFAPIE	flow_id;
    LFAPIE	fas_ip_addr;
    lfapui8_t	encode_flag;
} LFAP_AR;

    void resetLfapAR (LFAP_AR* ar, lfapui8_t resetFlags);
    void initLfapAR (LFAP_AR* ar);
    void initLfapARcommand (LFAP_AR* ar, lfapui8_t command);
    int initRcvdLfapAR (LFAP_AR* ar, void* buf, int buf_len);

    int setComponentLfapAR (LFAP_AR* ar, LFAPIE* ie);
    void setCommandLfapAR (LFAP_AR* ar, lfapui8_t command);
    void setFlowIdLfapAR (LFAP_AR* ar,
		lfapui32_t fas_id_hi,
		lfapui32_t fas_id_lo,
		lfapui32_t cce_id);
    void setFASIpAddrLfapAR (LFAP_AR* ar,
		char* addr,
		lfapui16_t family,
		lfapui16_t len);

    int encodeFixedLfapAR (LFAP_AR* ar);
    int encodeRecordLfapAR (LFAP_AR* ar);
    int encodeCompletedLfapAR (LFAP_AR* ar);
    int decodeNextRecordLfapAR (LFAP_AR* ar);
    lfapui8_t verifyLfapAR (LFAP_AR* ar);

#ifdef __cplusplus
}
#endif

#endif /* LFAPAR_H_ */
