/*******************************************************************************
**
**    Cabletron Systems Incorporated
**    Post Office Box 5005
**    Rochester, NH 03866-5005
**    (c) Copyright Cabletron Systems Inc. 1999
**
**    Workfile:             %M%
**    Logfile:              %P%
**    Original Author:      Todd Crowley
**    SCCS Delta ID:        %I%
**    Last Delta Date/Time: %G% %U%
**
*******************************************************************************/

#ifndef LFAPARA_H_
#define LFAPARA_H_

#include "Lfap.h"
#include "LfapAR.h"


#ifdef __cplusplus
extern "C" {
#endif

#define LFAP_ARA_INVALID		0
#define LFAP_ARA_VALID			1
#define LFAP_ARA_FLOW_ID		2
#define LFAP_ARA_FAIL_CODE		4
#define LFAP_ARA_FLOW_PREFIX		8
#define LFAP_ARA_TIME    	       16

typedef struct lfap_ara_msg
{
  LFAPBuffer	lfap_msg;
    LFAPHeader	hdr;
    LFAPIE	flow_id;
    LFAPIE	fail_code;
    LFAPIE	flow_prefix;
    LFAPIE	time;
    lfapui8_t	encode_flag;
} LFAP_ARA;

    void resetLfapARA (LFAP_ARA* ara, lfapui8_t resetFlags);
    void initLfapARA (LFAP_ARA* ara);
    void initLfapARAfromAR (LFAP_ARA* ara, LFAP_AR* ar);
    int initRcvdLfapARA (LFAP_ARA* ara, void* buf, int buf_len);

    int setComponentLfapARA (LFAP_ARA* ara, LFAPIE* ie);
    void setFailCodeLfapARA (LFAP_ARA* ara, lfapui32_t code);
    void setFlowIdLfapARA (LFAP_ARA* ara,
		lfapui32_t fas_id_hi,
		lfapui32_t fas_id_lo,
		lfapui32_t cce_id);
    void setFlowPrefixLfapARA (LFAP_ARA* ara,
		lfapui32_t fas_id_hi,
		lfapui32_t fas_id_lo);
    void setTimeLfapARA (LFAP_ARA* ara,
		lfapui32_t time);

    int encodeFixedLfapARA (LFAP_ARA* ara);
    int encodeRecordLfapARA (LFAP_ARA* ara);
    int encodeCompletedLfapARA (LFAP_ARA* ara);
    int decodeNextRecordLfapARA (LFAP_ARA* ara);
    lfapui8_t verifyLfapARA (LFAP_ARA* ara);

#ifdef __cplusplus
}
#endif

#endif /* LFAPARA_H_ */
