/*******************************************************************************
**
**    Cabletron Systems Incorporated
**    Post Office Box 5005
**    Rochester, NH 03866-5005
**    (c) Copyright Cabletron Systems Inc. 2001
**
**    Workfile:             %M%
**    Logfile:              %P%
**    Original Author:      Paul Calato
**    SCCS Delta ID:        %I%
**    Last Delta Date/Time: %G% %U%
**
*******************************************************************************/

#ifndef LFAPCAN_H_
#define LFAPCAN_H_

#include "Lfap.h"


#ifdef __cplusplus
extern "C" {
#endif

#define LFAP_CAN_INVALID			 0
#define LFAP_CAN_VALID			 1

typedef struct lfap_can_msg
{
    LFAPBuffer	lfap_msg;
    LFAPHeader	hdr;
} LFAP_CAN;

    void resetLfapCAN (LFAP_CAN* can);
    void initLfapCAN (LFAP_CAN* can);
    int initRcvdLfapCAN (LFAP_CAN* can, void* buf, int buf_len);

    int encodeCompletedLfapCAN (LFAP_CAN* can);
    lfapui8_t verifyLfapCAN (LFAP_CAN* can);

#ifdef __cplusplus
}
#endif

#endif /* LFAPCAN_H_ */
