/*******************************************************************************
**
**    Cabletron Systems Incorporated
**    Post Office Box 5005
**    Rochester, NH 03866-5005
**    (c) Copyright Cabletron Systems Inc. 2001
**
**    Workfile:             %M%
**    Logfile:              %P%
**    Original Author:      Paul Calato
**    SCCS Delta ID:        %I%
**    Last Delta Date/Time: %G% %U%
**
*******************************************************************************/

#ifndef LFAPCR_H_
#define LFAPCR_H_

#include "Lfap.h"


#ifdef __cplusplus
extern "C" {
#endif

#define LFAP_CR_INVALID			 0
#define LFAP_CR_VALID			 1
#define LFAP_CR_FAS_IP_ADDR		 1

typedef struct lfap_cr_msg
{
    LFAPBuffer	lfap_msg;
    LFAPHeader	hdr;
    LFAPIE	fas_ip_addr;
    lfapui8_t	encode_flag;
} LFAP_CR;

    void resetLfapCR (LFAP_CR* cr, lfapui8_t resetFlags);
    void initLfapCR (LFAP_CR* cr);
    int initRcvdLfapCR (LFAP_CR* cr, void* buf, int buf_len);

    int setComponentLfapCR (LFAP_CR* cr, LFAPIE* ie);
    void setFASIpAddrLfapCR (LFAP_CR* cr,
		char* addr,
		lfapui16_t family,
		lfapui16_t len);

    int encodeFixedLfapCR (LFAP_CR* cr);
    int encodeRecordLfapCR (LFAP_CR* cr);
    int encodeCompletedLfapCR (LFAP_CR* cr);
    int decodeNextRecordLfapCR (LFAP_CR* cr);
    lfapui8_t verifyLfapCR (LFAP_CR* cr);

#ifdef __cplusplus
}
#endif

#endif /* LFAPCR_H_ */
