/*******************************************************************************
**
**    Cabletron Systems Incorporated
**    Post Office Box 5005
**    Rochester, NH 03866-5005
**    (c) Copyright Cabletron Systems Inc. 2001
**
**    Workfile:             %M%
**    Logfile:              %P%
**    Original Author:      Paul Calato
**    SCCS Delta ID:        %I%
**    Last Delta Date/Time: %G% %U%
**
*******************************************************************************/

#ifndef LFAPCRN_H_
#define LFAPCRN_H_

#include "Lfap.h"


#ifdef __cplusplus
extern "C" {
#endif

#define LFAP_CRN_INVALID			 0
#define LFAP_CRN_VALID			 1

typedef struct lfap_crn_msg
{
    LFAPBuffer	lfap_msg;
    LFAPHeader	hdr;
} LFAP_CRN;

    void resetLfapCRN (LFAP_CRN* crn);
    void initLfapCRN (LFAP_CRN* crn);
    int initRcvdLfapCRN (LFAP_CRN* crn, void* buf, int buf_len);

    int encodeCompletedLfapCRN (LFAP_CRN* crn);
    lfapui8_t verifyLfapCRN (LFAP_CRN* crn);

#ifdef __cplusplus
}
#endif

#endif /* LFAPCRN_H_ */
