/*******************************************************************************
**
**    Cabletron Systems Incorporated
**    Post Office Box 5005
**    Rochester, NH 03866-5005
**    (c) Copyright Cabletron Systems Inc. 2001
**
**    Workfile:             %M%
**    Logfile:              %P%
**    Original Author:      Paul Calato
**    SCCS Delta ID:        %I%
**    Last Delta Date/Time: %G% %U%
**
*******************************************************************************/

#ifndef LFAPDR_H_
#define LFAPDR_H_

#include "Lfap.h"


#ifdef __cplusplus
extern "C" {
#endif

#define LFAP_DR_INVALID			 0
#define LFAP_DR_VALID			 1
#define LFAP_DR_FAS_IP_ADDR		 2

typedef struct lfap_dr_msg
{
    LFAPBuffer	lfap_msg;
    LFAPHeader	hdr;
    LFAPIE	fas_ip_addr;
    lfapui8_t	encode_flag;
} LFAP_DR;

    void resetLfapDR (LFAP_DR* dr, lfapui8_t resetFlags);
    void initLfapDR (LFAP_DR* dr);
    int initRcvdLfapDR (LFAP_DR* dr, void* buf, int buf_len);

    int setComponentLfapDR (LFAP_DR* dr, LFAPIE* ie);
    void setFASIpAddrLfapDR (LFAP_DR* dr,
		char* addr,
		lfapui16_t family,
		lfapui16_t len);

    int encodeFixedLfapDR (LFAP_DR* dr);
    int encodeRecordLfapDR (LFAP_DR* dr);
    int encodeCompletedLfapDR (LFAP_DR* dr);
    int decodeNextRecordLfapDR (LFAP_DR* dr);
    lfapui8_t verifyLfapDR (LFAP_DR* dr);

#ifdef __cplusplus
}
#endif

#endif /* LFAPDR_H_ */
