/*******************************************************************************
**
**    Cabletron Systems Incorporated
**    Post Office Box 5005
**    Rochester, NH 03866-5005
**    (c) Copyright Cabletron Systems Inc. 2001
**
**    Workfile:             %M%
**    Logfile:              %P%
**    Original Author:      Paul Calato
**    SCCS Delta ID:        %I%
**    Last Delta Date/Time: %G% %U%
**
*******************************************************************************/

#ifndef LFAPFER_H_
#define LFAPFER_H_

#include "Lfap.h"


#ifdef __cplusplus
extern "C" {
#endif

#define LFAP_FER_INVALID			 0
#define LFAP_FER_VALID			 1

typedef struct lfap_fer_msg
{
    LFAPBuffer	lfap_msg;
    LFAPHeader	hdr;
} LFAP_FER;

    void resetLfapFER (LFAP_FER* fer);
    void initLfapFER (LFAP_FER* fer);
    int initRcvdLfapFER (LFAP_FER* fer, void* buf, int buf_len);

    int encodeCompletedLfapFER (LFAP_FER* fer);
    lfapui8_t verifyLfapFER (LFAP_FER* fer);

#ifdef __cplusplus
}
#endif

#endif /* LFAPFER_H_ */
