/*******************************************************************************
**
**    Cabletron Systems Incorporated
**    Post Office Box 5005
**    Rochester, NH 03866-5005
**    (c) Copyright Cabletron Systems Inc. 1999
**
**    Workfile:             %M%
**    Logfile:              %P%
**    Original Author:      Todd Crowley
**    SCCS Delta ID:        %I%
**    Last Delta Date/Time: %G% %U%
**
*******************************************************************************/

#ifndef LFAPFUN_H_
#define LFAPFUN_H_

#include "Lfap.h"


#ifdef __cplusplus
extern "C" {
#endif

#define LFAP_FUN_INVALID		0
#define LFAP_FUN_VALID			1
#define LFAP_FUN_TIME			1
#define LFAP_FUN_FLOW_ID		1
#define LFAP_FUN_FLOW_STATE		2
#define LFAP_FUN_BYTE_COUNT		4
#define LFAP_FUN_PACKET_COUNT		8

typedef struct lfap_fun_msg
{
    LFAPBuffer	lfap_msg;
    LFAPHeader	hdr;
    LFAPIE	flow_id;
    LFAPIE	flow_state;
    LFAPIE	time;
    LFAPIE	byte_count;
    LFAPIE	packet_count;
    lfapui8_t	encode_flag;
} LFAP_FUN;

    void resetLfapFUN (LFAP_FUN* fun, lfapui8_t resetFlags);
    void initLfapFUN (LFAP_FUN* fun);
    void initLfapFUNflowId (LFAP_FUN* fun,
		lfapui32_t fas_id_hi,
		lfapui32_t fas_id_lo,
		lfapui32_t cce_id);
    int initRcvdLfapFUN (LFAP_FUN* fun, void* buf, int buf_len);

    int setComponentLfapFUN (LFAP_FUN* fun, LFAPIE* ie);
    void setFlowIdLfapFUN (LFAP_FUN* fun,
		lfapui32_t fas_id_hi,
		lfapui32_t fas_id_lo,
		lfapui32_t cce_id);
    void setStateLfapFUN (LFAP_FUN* fun,
		lfapui32_t state);
    void setTimeLfapFUN (LFAP_FUN* fun,
		lfapui32_t time);
    void setByteCountLfapFUN (LFAP_FUN* fun,
		lfapui16_t type,
		lfapui64_t rcvd,
		lfapui64_t sent);
    void setPacketCountLfapFUN (LFAP_FUN* fun,
		lfapui16_t type,
		lfapui64_t rcvd,
		lfapui64_t sent);

    int encodeFixedLfapFUN (LFAP_FUN* fun);
    int encodeRecordLfapFUN (LFAP_FUN* fun);
    int encodeCompletedLfapFUN (LFAP_FUN* fun);
    int decodeNextRecordLfapFUN (LFAP_FUN* fun);
    lfapui8_t verifyLfapFUN (LFAP_FUN* fun);

#ifdef __cplusplus
}
#endif

#endif /* LFAPFUN_H_ */
