/*******************************************************************************
**
**    Cabletron Systems Incorporated
**    Post Office Box 5005
**    Rochester, NH 03866-5005
**    (c) Copyright Cabletron Systems Inc. 2001
**
**    Workfile:             %M%
**    Logfile:              %P%
**    Original Author:      Paul Calato
**    SCCS Delta ID:        %I%
**    Last Delta Date/Time: %G% %U%
**
*******************************************************************************/

#ifndef LFAPKA_H_
#define LFAPKA_H_

#include "Lfap.h"


#ifdef __cplusplus
extern "C" {
#endif

#define LFAP_KA_INVALID			 0
#define LFAP_KA_VALID			 1

typedef struct lfap_ka_msg
{
    LFAPBuffer	lfap_msg;
    LFAPHeader	hdr;
} LFAP_KA;

    void resetLfapKA (LFAP_KA* ka);
    void initLfapKA (LFAP_KA* ka);
    int initRcvdLfapKA (LFAP_KA* ka, void* buf, int buf_len);

    int encodeCompletedLfapKA (LFAP_KA* ka);
    lfapui8_t verifyLfapKA (LFAP_KA* ka);

#ifdef __cplusplus
}
#endif

#endif /* LFAPKA_H_ */
