/*******************************************************************************
**
**    Cabletron Systems Incorporated
**    Post Office Box 5005
**    Rochester, NH 03866-5005
**    (c) Copyright Cabletron Systems Inc. 1999
**
**    Workfile:             %M%
**    Logfile:              %P%
**    Original Author:      Todd Crowley
**    SCCS Delta ID:        %I%
**    Last Delta Date/Time: %G% %U%
**
*******************************************************************************/

#ifndef LFAPMSGQUEUE_H_
#define LFAPMSGQUEUE_H_

#include "LfapList.h"
#include "LfapStruct.h"


#ifdef __cplusplus
extern "C" {
#endif


/* total number of messages allowed in queues */
#define LFAP_MAX_RCVD_QUEUE_SIZE        10000
#define LFAP_MAX_FREE_RCVD_QUEUE_SIZE    1000
#define LFAP_MAX_FREE_SEND_QUEUE_SIZE    1000

/* send queue messages are requrired or optional */
#define LFAP_REQ_MSG	1
#define LFAP_OPT_MSG	2

/*
 *  all queues
 */
    void initializeLfapMsgQueues (void);
    void terminateLfapMsgQueues (void);


/*
 *  sending queues
 */
    lfapui16_t addMsgToLfapRegSendQueue (void* buf, unsigned int len,
                                         int status);
    lfapui16_t addMsgToLfapHighSendQueue (void* buf, unsigned int len,
                                          int status);

    unsigned int msgsInLfapRegSendQueue (void);
    unsigned int msgsInLfapHighSendQueue (void);

    LFAPNode* getMsgFromLfapRegSendQueue (void);
    LFAPNode* getMsgFromLfapHighSendQueue (void);

    void returnLfapSendMsg (LFAPNode* msg);


/*
 *  receiving queues
 */
    lfapui16_t addMsgToLfapRegRcvdQueue (void* buf, unsigned int len);
    lfapui16_t addMsgToLfapHighRcvdQueue (void* buf, unsigned int len);

    unsigned int msgsInLfapRegRcvdQueue (void);
    unsigned int msgsInLfapHighRcvdQueue (void);

    LFAPNode* getMsgFromLfapRegRcvdQueue (void);
    LFAPNode* getMsgFromLfapHighRcvdQueue (void);

    void returnLfapRcvdMsg (LFAPNode* msg);


#ifdef __cplusplus
}
#endif

#endif /* LFAPMSGQUEUE_H_ */
