/*******************************************************************************
**
**    Cabletron Systems Incorporated
**    Post Office Box 5005
**    Rochester, NH 03866-5005
**    (c) Copyright Cabletron Systems Inc. 1999
**
**    Workfile:             %M%
**    Logfile:              %P%
**    Original Author:      Todd Crowley
**    SCCS Delta ID:        %I%
**    Last Delta Date/Time: %G% %U%
**
*******************************************************************************/

#ifndef LFAPPROTO_H_
#define LFAPPROTO_H_

/*
 * function prototypes for lfap library
 */

#ifndef LFAPFUNCDECL
#ifdef _WIN32
#define LFAPFUNCDECL    __declspec( dllexport )
#else /* _WIN32 */
#define LFAPFUNCDECL
#endif /* _WIN32 */
#endif /* LFAPFUNCDECL */

LFAPFUNCDECL int lfap_add_IE(LFAPBuffer *lbuf, LFAPIE *ie);

LFAPFUNCDECL int lfap_begin_message(LFAPBuffer *lbuf, LFAPHeader *hdr);
LFAPFUNCDECL int lfap_end_message(LFAPBuffer *lbuf);

LFAPFUNCDECL int lfap_begin_multiple(LFAPBuffer *lbuf);
LFAPFUNCDECL int lfap_end_multiple(LFAPBuffer *lbuf);

LFAPFUNCDECL int lfap_begin_fixed(LFAPBuffer *lbuf);
LFAPFUNCDECL int lfap_end_fixed(LFAPBuffer *lbuf);

LFAPFUNCDECL int lfap_begin_record(LFAPBuffer *lbuf);
LFAPFUNCDECL int lfap_end_record(LFAPBuffer *lbuf);

LFAPFUNCDECL int lfap_decode_msglen(void *buf);
LFAPFUNCDECL int lfap_get_header(LFAPBuffer *lbuf, LFAPHeader *hdr);
LFAPFUNCDECL int lfap_get_IE(LFAPBuffer *lbuf, LFAPIE *ie);
LFAPFUNCDECL int lfap_next_record(LFAPBuffer *lbuf);

LFAPFUNCDECL int lfap_buffer_init(LFAPBuffer *lbuf, void *buf, int buflen);
LFAPFUNCDECL void lfap_buffer_reset(LFAPBuffer *lbuf);
LFAPFUNCDECL lfapui8_t* lfap_buffer_extract(LFAPBuffer *lbuf, int nbyte);
LFAPFUNCDECL lfapui8_t* lfap_buffer_insert(LFAPBuffer *lbuf, int nbyte);

#endif
