/*******************************************************************************
**
**    Cabletron Systems Incorporated
**    Post Office Box 5005
**    Rochester, NH 03866-5005
**    (c) Copyright Cabletron Systems Inc. 1999
**
**    Workfile:             %M%
**    Logfile:              %P%
**    Original Author:      Todd Crowley
**    SCCS Delta ID:        %I%
**    Last Delta Date/Time: %G% %U%
**
*******************************************************************************/

#ifndef LFAPVRA_H_
#define LFAPVRA_H_

#include "Lfap.h"
#include "LfapVR.h"


#ifdef __cplusplus
extern "C" {
#endif

#define LFAP_VRA_INVALID		 0
#define LFAP_VRA_VALID			 1

typedef struct lfap_vra_msg
{
    LFAPBuffer	lfap_msg;
    LFAPHeader	hdr;
} LFAP_VRA;

    void resetLfapVRA (LFAP_VRA* vra);
    void initLfapVRA (LFAP_VRA* vra);
    void initLfapVRAfromVR (LFAP_VRA* vra, LFAP_VR* vr);
    int initRcvdLfapVRA (LFAP_VRA* vra, void* buf, int buf_len);

    int encodeCompletedLfapVRA (LFAP_VRA* vra);
    lfapui8_t verifyLfapVRA (LFAP_VRA* vra);

#ifdef __cplusplus
}
#endif

#endif /* LFAPVRA_H_ */
