/*******************************************************************************
**
**    Cabletron Systems Incorporated
**    Post Office Box 5005
**    Rochester, NH 03866-5005
**    (c) Copyright Cabletron Systems Inc. 2001
**
**    Workfile:             %M%
**    Logfile:              %P%
**    Original Author:      Paul Calato
**    SCCS Delta ID:        %I%
**    Last Delta Date/Time: %G% %U%
**
*******************************************************************************/

/* Start of auto-generated includes */
#define INCLUDES_H_
#ifdef MLS_SOL_BUILD
#include "sol_includes.h"
#endif
#ifdef MLS_MIPS_BUILD
#endif
/* End of auto-generated includes */

#include "LfapCAN.h"
#include "LfapMsg.h"


/******************************************************************************/
/*                                                                            */
/*  Function: resetLfapCAN                                                     */
/*                                                                            */
/*  Resets the internal IEs of the LFAP_CAN message structure to 0.            */
/*                                                                            */
/******************************************************************************/
void resetLfapCAN (LFAP_CAN* can)
{
}

/******************************************************************************/
/*                                                                            */
/*  Function: initLfapCAN                                                      */
/*                                                                            */
/*  Initializes the internals of the LFAP_CAN message structure.               */
/*                                                                            */
/******************************************************************************/
void initLfapCAN (LFAP_CAN* can)
{
    lfap_buffer_init(&(can->lfap_msg), 0, 0);

    can->hdr.opcode = LFAP_CAN_OPCODE;
    can->hdr.status = LFAP_MSG_SUCCESS;
    can->hdr.msgid = getNextLfapMsgId();
}

/******************************************************************************/
/*                                                                            */
/*  Function: initRcvdLfapCAN                                                  */
/*                                                                            */
/*  Initializes the internals of the LFAP_CAN message structure, from a        */
/*  received message.  LFAP_SUCCESS is returned upon success, LFAP_ERROR is   */
/*  returned if there is an error.  lfap_buffer_get_error(&can->lfap_msg) can be    */
/*  used if there is an error.                                                */
/*                                                                            */
/******************************************************************************/
int initRcvdLfapCAN (LFAP_CAN* can, void* buf, int buf_len)
{
    lfap_buffer_init(&can->lfap_msg, buf, buf_len);
    lfap_buffer_insert(&can->lfap_msg, buf_len);

    return lfap_get_header(&can->lfap_msg, &can->hdr);
}

/******************************************************************************/
/*                                                                            */
/*  Function: encodeCompletedLfapCAN                                           */
/*                                                                            */
/*  Encodes the LFAP_CAN message.  The LFAP_CAN message (in the form of the     */
/*  LFAPBuffer) is ready to be sent.                                          */
/*                                                                            */
/******************************************************************************/
int encodeCompletedLfapCAN (LFAP_CAN* can)
{
    LFAPBuffer* can_buf = &(can->lfap_msg);
    lfap_begin_message(can_buf, &can->hdr);
    return lfap_end_message(can_buf);
}

/******************************************************************************/
/*                                                                            */
/*  Function: verifyLfapCAN                                                    */
/*                                                                            */
/*  Verifies which IEs of the received LFAP_CAN message are encoded.           */
/*  LFAP_CAN_VALID is always returned, as a LFAP_CAN message does not have      */
/*  any IEs.                                                                  */
/*                                                                            */
/******************************************************************************/
lfapui8_t verifyLfapCAN (LFAP_CAN* can)
{
    return LFAP_CAN_VALID;
}
