/*******************************************************************************
**
**    Cabletron Systems Incorporated
**    Post Office Box 5005
**    Rochester, NH 03866-5005
**    (c) Copyright Cabletron Systems Inc. 2001
**
**    Workfile:             %M%
**    Logfile:              %P%
**    Original Author:      Paul Calato
**    SCCS Delta ID:        %I%
**    Last Delta Date/Time: %G% %U%
**
*******************************************************************************/

/* Start of auto-generated includes */
#define INCLUDES_H_
#ifdef MLS_SOL_BUILD
#include "sol_includes.h"
#endif
#ifdef MLS_MIPS_BUILD
#endif
/* End of auto-generated includes */

#include "LfapCRN.h"
#include "LfapMsg.h"


/******************************************************************************/
/*                                                                            */
/*  Function: resetLfapCRN                                                     */
/*                                                                            */
/*  Resets the internal IEs of the LFAP_CRN message structure to 0.            */
/*                                                                            */
/******************************************************************************/
void resetLfapCRN (LFAP_CRN* crn)
{
}

/******************************************************************************/
/*                                                                            */
/*  Function: initLfapCRN                                                      */
/*                                                                            */
/*  Initializes the internals of the LFAP_CRN message structure.               */
/*                                                                            */
/******************************************************************************/
void initLfapCRN (LFAP_CRN* crn)
{
    lfap_buffer_init(&(crn->lfap_msg), 0, 0);

    crn->hdr.opcode = LFAP_CRN_OPCODE;
    crn->hdr.status = LFAP_MSG_SUCCESS;
    crn->hdr.msgid = getNextLfapMsgId();
}

/******************************************************************************/
/*                                                                            */
/*  Function: initRcvdLfapCRN                                                  */
/*                                                                            */
/*  Initializes the internals of the LFAP_CRN message structure, from a        */
/*  received message.  LFAP_SUCCESS is returned upon success, LFAP_ERROR is   */
/*  returned if there is an error.  lfap_buffer_get_error(&crn->lfap_msg) can be    */
/*  used if there is an error.                                                */
/*                                                                            */
/******************************************************************************/
int initRcvdLfapCRN (LFAP_CRN* crn, void* buf, int buf_len)
{
    lfap_buffer_init(&crn->lfap_msg, buf, buf_len);
    lfap_buffer_insert(&crn->lfap_msg, buf_len);

    return lfap_get_header(&crn->lfap_msg, &crn->hdr);
}

/******************************************************************************/
/*                                                                            */
/*  Function: encodeCompletedLfapCRN                                           */
/*                                                                            */
/*  Encodes the LFAP_CRN message.  The LFAP_CRN message (in the form of the     */
/*  LFAPBuffer) is ready to be sent.                                          */
/*                                                                            */
/******************************************************************************/
int encodeCompletedLfapCRN (LFAP_CRN* crn)
{
    LFAPBuffer* crn_buf = &(crn->lfap_msg);
    lfap_begin_message(crn_buf, &crn->hdr);
    return lfap_end_message(crn_buf);
}

/******************************************************************************/
/*                                                                            */
/*  Function: verifyLfapCRN                                                    */
/*                                                                            */
/*  Verifies which IEs of the received LFAP_CRN message are encoded.           */
/*  LFAP_CRN_VALID is always returned, as a LFAP_CRN message does not have      */
/*  any IEs.                                                                  */
/*                                                                            */
/******************************************************************************/
lfapui8_t verifyLfapCRN (LFAP_CRN* crn)
{
    return LFAP_CRN_VALID;
}
