/*******************************************************************************
**
**    Cabletron Systems Incorporated
**    Post Office Box 5005
**    Rochester, NH 03866-5005
**    (c) Copyright Cabletron Systems Inc. 2001
**
**    Workfile:             %M%
**    Logfile:              %P%
**    Original Author:      Paul Calato
**    SCCS Delta ID:        %I%
**    Last Delta Date/Time: %G% %U%
**
*******************************************************************************/

/* Start of auto-generated includes */
#define INCLUDES_H_
#ifdef MLS_SOL_BUILD
#include "sol_includes.h"
#endif
#ifdef MLS_MIPS_BUILD
#endif
/* End of auto-generated includes */

#include "LfapFER.h"
#include "LfapMsg.h"


/******************************************************************************/
/*                                                                            */
/*  Function: resetLfapFER                                                     */
/*                                                                            */
/*  Resets the internal IEs of the LFAP_FER message structure to 0.            */
/*                                                                            */
/******************************************************************************/
void resetLfapFER (LFAP_FER* fer)
{
}

/******************************************************************************/
/*                                                                            */
/*  Function: initLfapFER                                                      */
/*                                                                            */
/*  Initializes the internals of the LFAP_FER message structure.               */
/*                                                                            */
/******************************************************************************/
void initLfapFER (LFAP_FER* fer)
{
    lfap_buffer_init(&(fer->lfap_msg), 0, 0);

    fer->hdr.opcode = LFAP_FER_OPCODE;
    fer->hdr.status = LFAP_MSG_SUCCESS;
    fer->hdr.msgid = getNextLfapMsgId();
}

/******************************************************************************/
/*                                                                            */
/*  Function: initRcvdLfapFER                                                  */
/*                                                                            */
/*  Initializes the internals of the LFAP_FER message structure, from a        */
/*  received message.  LFAP_SUCCESS is returned upon success, LFAP_ERROR is   */
/*  returned if there is an error.  lfap_buffer_get_error(&fer->lfap_msg) can be    */
/*  used if there is an error.                                                */
/*                                                                            */
/******************************************************************************/
int initRcvdLfapFER (LFAP_FER* fer, void* buf, int buf_len)
{
    lfap_buffer_init(&fer->lfap_msg, buf, buf_len);
    lfap_buffer_insert(&fer->lfap_msg, buf_len);

    return lfap_get_header(&fer->lfap_msg, &fer->hdr);
}

/******************************************************************************/
/*                                                                            */
/*  Function: encodeCompletedLfapFER                                           */
/*                                                                            */
/*  Encodes the LFAP_FER message.  The LFAP_FER message (in the form of the     */
/*  LFAPBuffer) is ready to be sent.                                          */
/*                                                                            */
/******************************************************************************/
int encodeCompletedLfapFER (LFAP_FER* fer)
{
    LFAPBuffer* fer_buf = &(fer->lfap_msg);
    lfap_begin_message(fer_buf, &fer->hdr);
    return lfap_end_message(fer_buf);
}

/******************************************************************************/
/*                                                                            */
/*  Function: verifyLfapFER                                                    */
/*                                                                            */
/*  Verifies which IEs of the received LFAP_FER message are encoded.           */
/*  LFAP_FER_VALID is always returned, as a LFAP_FER message does not have      */
/*  any IEs.                                                                  */
/*                                                                            */
/******************************************************************************/
lfapui8_t verifyLfapFER (LFAP_FER* fer)
{
    return LFAP_FER_VALID;
}
