/*******************************************************************************
**
**    Cabletron Systems Incorporated
**    Post Office Box 5005
**    Rochester, NH 03866-5005
**    (c) Copyright Cabletron Systems Inc. 2001
**
**    Workfile:             %M%
**    Logfile:              %P%
**    Original Author:      Paul Calato
**    SCCS Delta ID:        %I%
**    Last Delta Date/Time: %G% %U%
**
*******************************************************************************/

/* Start of auto-generated includes */
#define INCLUDES_H_
#ifdef MLS_SOL_BUILD
#include "sol_includes.h"
#endif
#ifdef MLS_MIPS_BUILD
#endif
/* End of auto-generated includes */

#include "LfapKA.h"
#include "LfapMsg.h"


/******************************************************************************/
/*                                                                            */
/*  Function: resetLfapKA                                                     */
/*                                                                            */
/*  Resets the internal IEs of the LFAP_KA message structure to 0.            */
/*                                                                            */
/******************************************************************************/
void resetLfapKA (LFAP_KA* ka)
{
}

/******************************************************************************/
/*                                                                            */
/*  Function: initLfapKA                                                      */
/*                                                                            */
/*  Initializes the internals of the LFAP_KA message structure.               */
/*                                                                            */
/******************************************************************************/
void initLfapKA (LFAP_KA* ka)
{
    lfap_buffer_init(&(ka->lfap_msg), 0, 0);

    ka->hdr.opcode = LFAP_KA_OPCODE;
    ka->hdr.status = LFAP_MSG_SUCCESS;
    ka->hdr.msgid = getNextLfapMsgId();
}

/******************************************************************************/
/*                                                                            */
/*  Function: initRcvdLfapKA                                                  */
/*                                                                            */
/*  Initializes the internals of the LFAP_KA message structure, from a        */
/*  received message.  LFAP_SUCCESS is returned upon success, LFAP_ERROR is   */
/*  returned if there is an error.  lfap_buffer_get_error(&ka->lfap_msg) can be    */
/*  used if there is an error.                                                */
/*                                                                            */
/******************************************************************************/
int initRcvdLfapKA (LFAP_KA* ka, void* buf, int buf_len)
{
    lfap_buffer_init(&ka->lfap_msg, buf, buf_len);
    lfap_buffer_insert(&ka->lfap_msg, buf_len);

    return lfap_get_header(&ka->lfap_msg, &ka->hdr);
}

/******************************************************************************/
/*                                                                            */
/*  Function: encodeCompletedLfapKA                                           */
/*                                                                            */
/*  Encodes the LFAP_KA message.  The LFAP_KA message (in the form of the     */
/*  LFAPBuffer) is ready to be sent.                                          */
/*                                                                            */
/******************************************************************************/
int encodeCompletedLfapKA (LFAP_KA* ka)
{
    LFAPBuffer* ka_buf = &(ka->lfap_msg);
    lfap_begin_message(ka_buf, &ka->hdr);
    return lfap_end_message(ka_buf);
}

/******************************************************************************/
/*                                                                            */
/*  Function: verifyLfapKA                                                    */
/*                                                                            */
/*  Verifies which IEs of the received LFAP_KA message are encoded.           */
/*  LFAP_KA_VALID is always returned, as a LFAP_KA message does not have      */
/*  any IEs.                                                                  */
/*                                                                            */
/******************************************************************************/
lfapui8_t verifyLfapKA (LFAP_KA* ka)
{
    return LFAP_KA_VALID;
}
