/*******************************************************************************
**
**    Cabletron Systems Incorporated
**    Post Office Box 5005
**    Rochester, NH 03866-5005
**    (c) Copyright Cabletron Systems Inc. 1999
**
**    Workfile:             %M%
**    Logfile:              %P%
**    Original Author:      Todd Crowley
**    SCCS Delta ID:        %I%
**    Last Delta Date/Time: %G% %U%
**
*******************************************************************************/

/* Start of auto-generated includes */
#define INCLUDES_H_
#ifdef MLS_SOL_BUILD
#include "sol_includes.h"
#endif
#ifdef MLS_MIPS_BUILD
#endif
/* End of auto-generated includes */

#include "LfapMsg.h"


/* Every message type uses this message id, guaranteeing uniqueness,
   even between different message types */
static lfapui16_t nextLfapMsgId = 0;

/******************************************************************************/
/*                                                                            */
/*  Function: freeLfapMsg                                                     */
/*                                                                            */
/*  Free's the memory used by the LFAPBuffer inside of a LFAP message.        */
/*                                                                            */
/******************************************************************************/
void freeLfapMsg (void* msg)
{
    LFAPMsg* lfap_msg = (LFAPMsg*) msg;
    lfap_buffer_free(&(lfap_msg->buf));
}

/******************************************************************************/
/*                                                                            */
/*  Function: getNextLfapMsgId                                                */
/*                                                                            */
/*  Returns the next message id (nextLfapMsgId is increased by 1 every time   */
/*  this is called).                                                          */
/*                                                                            */
/******************************************************************************/
lfapui16_t getNextLfapMsgId (void)
{
    return ++nextLfapMsgId;
}

/******************************************************************************/
/*                                                                            */
/*  Function: setLfapMsgId                                                    */
/*                                                                            */
/*  Sets the msgid of the given message.                                      */
/*                                                                            */
/******************************************************************************/
void setLfapMsgId (void* msg, lfapui16_t msgid)
{
    LFAPMsg* lfap_msg = (LFAPMsg*) msg;
    lfap_msg->hdr.msgid = msgid;
}

/******************************************************************************/
/*                                                                            */
/*  Function: setLfapMsgStatus                                                */
/*                                                                            */
/*  Sets the status of the given message.                                     */
/*                                                                            */
/******************************************************************************/
void setLfapMsgStatus (void* msg, lfapui8_t status)
{
    LFAPMsg* lfap_msg = (LFAPMsg*) msg;
    lfap_msg->hdr.status = status;
}
