/*******************************************************************************
**
**    Cabletron Systems Incorporated
**    Post Office Box 5005
**    Rochester, NH 03866-5005
**    (c) Copyright Cabletron Systems Inc. 1999
**
**    Workfile:             %M%
**    Logfile:              %P%
**    Original Author:      Todd Crowley
**    SCCS Delta ID:        %I%
**    Last Delta Date/Time: %G% %U%
**
*******************************************************************************/

/* Start of auto-generated includes */
#define INCLUDES_H_
#ifdef MLS_SOL_BUILD
#include "sol_includes.h"
#endif
#ifdef MLS_MIPS_BUILD
#endif
/* End of auto-generated includes */

#include "LfapVR.h"
#include "LfapMsg.h"


/******************************************************************************/
/*                                                                            */
/*  Function: resetLfapVR                                                     */
/*                                                                            */
/*  Resets the internal IEs of the LFAP_VR message structure to 0.            */
/*                                                                            */
/******************************************************************************/
void resetLfapVR (LFAP_VR* vr)
{
}

/******************************************************************************/
/*                                                                            */
/*  Function: initLfapVR                                                      */
/*                                                                            */
/*  Initializes the internals of the LFAP_VR message structure.               */
/*                                                                            */
/******************************************************************************/
void initLfapVR (LFAP_VR* vr)
{
    lfap_buffer_init(&(vr->lfap_msg), 0, 0);

    vr->hdr.opcode = LFAP_VR_OPCODE;
    vr->hdr.status = LFAP_MSG_SUCCESS;
    vr->hdr.msgid = getNextLfapMsgId();
}

/******************************************************************************/
/*                                                                            */
/*  Function: initRcvdLfapVR                                                  */
/*                                                                            */
/*  Initializes the internals of the LFAP_VR message structure, from a        */
/*  received message.  LFAP_SUCCESS is returned upon success, LFAP_ERROR is   */
/*  returned if there is an error. lfap_buffer_get_error(&vr->lfap_msg) can   */
/*  be used if there is an error.                                             */
/*                                                                            */
/******************************************************************************/
int initRcvdLfapVR (LFAP_VR* vr, void* buf, int buf_len)
{
  lfap_buffer_init(&vr->lfap_msg, buf, buf_len);
  lfap_buffer_insert(&vr->lfap_msg, buf_len);

  return lfap_get_header(&vr->lfap_msg, &vr->hdr);
}

/******************************************************************************/
/*                                                                            */
/*  Function: encodeCompletedLfapVR                                           */
/*                                                                            */
/*  Encodes the LFAP_VR message.  The LFAP_VR message (in the form of the     */
/*  LFAPBuffer) is ready to be sent.                                          */
/*                                                                            */
/******************************************************************************/
int encodeCompletedLfapVR (LFAP_VR* vr)
{
    LFAPBuffer* vr_buf = &(vr->lfap_msg);
    lfap_begin_message(vr_buf, &vr->hdr);
    return lfap_end_message(vr_buf);
}

/******************************************************************************/
/*                                                                            */
/*  Function: verifyLfapVR                                                    */
/*                                                                            */
/*  Verifies which IEs of the received LFAP_VR message are encoded.           */
/*  LFAP_VR_VALID is always returned, as a LFAP_VR message does not have      */
/*  any IEs.                                                                  */
/*                                                                            */
/******************************************************************************/
lfapui8_t verifyLfapVR (LFAP_VR* vr)
{
    return LFAP_VR_VALID;
}
