/*******************************************************************************
**
**    Cabletron Systems Incorporated
**    Post Office Box 5005
**    Rochester, NH 03866-5005
**    (c) Copyright Cabletron Systems Inc. 1999
**
**    Workfile:             %M%
**    Logfile:              %P%
**    Original Author:      Todd Crowley
**    SCCS Delta ID:        %I%
**    Last Delta Date/Time: %G% %U%
**
*******************************************************************************/

/* Start of auto-generated includes */
#define INCLUDES_H_
#ifdef MLS_SOL_BUILD
#include "sol_includes.h"
#endif
#ifdef MLS_MIPS_BUILD
#endif
/* End of auto-generated includes */

#include "LfapVRA.h"
#include "LfapMsg.h"


/******************************************************************************/
/*                                                                            */
/*  Function: resetLfapVRA                                                    */
/*                                                                            */
/*  Resets the internal IEs of the LFAP_VRA message structure to 0.           */
/*                                                                            */
/******************************************************************************/
void resetLfapVRA (LFAP_VRA* vra)
{
}

/******************************************************************************/
/*                                                                            */
/*  Function: initLfapVRA                                                     */
/*                                                                            */
/*  Initializes the internals of the LFAP_VRA message structure.              */
/*                                                                            */
/******************************************************************************/
void initLfapVRA (LFAP_VRA* vra)
{
    lfap_buffer_init(&(vra->lfap_msg), 0, 0);

    vra->hdr.opcode = LFAP_VRA_OPCODE;
    vra->hdr.status = LFAP_MSG_SUCCESS;
    vra->hdr.msgid = getNextLfapMsgId();
}

/******************************************************************************/
/*                                                                            */
/*  Function: initLfapVRAfromVR                                               */
/*                                                                            */
/*  Initializes the internals of the LFAP_VRA message structure, from a       */
/*  received LFAP_VR message.                                                 */
/*                                                                            */
/******************************************************************************/
void initLfapVRAfromVR (LFAP_VRA* vra, LFAP_VR* vr)
{
    lfap_buffer_init(&(vra->lfap_msg), 0, 0);

    vra->hdr.opcode = LFAP_VRA_OPCODE;
    vra->hdr.status = vr->hdr.status;
    vra->hdr.msgid = vr->hdr.msgid;
}

/******************************************************************************/
/*                                                                            */
/*  Function: initRcvdLfapVRA                                                 */
/*                                                                            */
/*  Initializes the internals of the LFAP_VRA message structure, from a       */
/*  received message.  LFAP_SUCCESS is returned upon success, LFAP_ERROR is   */
/*  returned if there is an error. lfap_buffer_get_error(&vra->lfap_msg) can  */
/*  be   used if there is an error.                                           */
/*                                                                            */
/******************************************************************************/
int initRcvdLfapVRA (LFAP_VRA* vra, void* buf, int buf_len)
{
  lfap_buffer_init(&vra->lfap_msg, buf, buf_len);
  lfap_buffer_insert(&vra->lfap_msg, buf_len);

  return lfap_get_header(&vra->lfap_msg, &vra->hdr);
}

/******************************************************************************/
/*                                                                            */
/*  Function: encodeCompletedLfapVRA                                          */
/*                                                                            */
/*  Encodes the LFAP_VRA message.  The LFAP_VRA message (in the form of the   */
/*  LFAPBuffer) is ready to be sent.                                          */
/*                                                                            */
/******************************************************************************/
int encodeCompletedLfapVRA (LFAP_VRA* vra)
{
    LFAPBuffer* vra_buf = &(vra->lfap_msg);
    lfap_begin_message(vra_buf, &vra->hdr);
    return lfap_end_message(vra_buf);
}

/******************************************************************************/
/*                                                                            */
/*  Function: verifyLfapVRA                                                   */
/*                                                                            */
/*  Verifies which IEs of the received LFAP_VRA message are encoded.          */
/*  LFAP_VRA_VALID is always returned, as a LFAP_VRA message does not have    */
/*  any IEs.                                                                  */
/*                                                                            */
/******************************************************************************/
lfapui8_t verifyLfapVRA (LFAP_VRA* vra)
{
    return LFAP_VRA_VALID;
}
